* MW: implement ML toplevel spans in official Isabelle, e.g.
  with separator \<^medskip> and some tool support for automated
  update (in "isabelle update" and/or PIDE);

* MW?: rename *.sml to *.ML, potentially with tool support;

* MW: clarify/eliminate Isabelle/Scala add-ons (presently unused)

    diff -r /home/makarius/isabelle/repos-Isabelle2021/src/Pure/build-jars ./src/Pure/build-jars
    11a12
    >   src/Tools/isac/BridgeJEdit/isac.scala

    diff -r /home/makarius/isabelle/repos-Isabelle2021/src/Pure/Tools/scala_project.scala ./src/Pure/Tools/scala_project.scala
    76a77
    >       "src/Tools/isac/etc" -> Path.explode("isabelle.isac"),

* MW: Skip_Proof.make_thm: theory -> term -> thm        ? could now change signature to
                         : Proof.context -> term -> thm
* MW: Make $ISABELLE_ISAC_TEST work without sessions (please synchronise with WN)
* MW: ? implement a template, inserted in a proof in the line of metis;
      hints are given in src/../BridgeJEdit/template.sml
      and in            test/../BridgeJEdit/template.sml

***** some items for discussion

* Clarify symmetric rule: Thm.apply_attribute Calculation.symmetric thm context (!?);
    ??

* "fun pr_ord" is not required if used with @{make_string}, @{print}, @{print tracing};
    takes only static arguments ----------------^^^^^^^^^^^^^^, not value of "hd_ord (f, g)"
    ? are there better approximations to old output of (*1*) than with (*2*)
    (*1*)val _ = tracing ("hd_ord (f, g)      = " ^ ((pr_ord o hd_ord) (f, g)) );
    (*2*)val _ = @{print tracing}{a = "hd_ord (f, g)      = ", z = hd_ord (f, g)}(**)


***** for the few items below WN asks MW for help

* postpone: ?How accomplish two user-requirements by Outer_Syntax.command \<^command_keyword>\<open>Example\<close>
   (1) start a Calculation with a CAS_Cmd
   (2) start an Example from scratch, i.e. with (Formalize.empty, References.empty)
   Proposals for a solution are in test/../Test_VSCode_Example.thy
   in subsubsection ‹Start Example with a CAS_Cmd›


***** priority of WN items is top down, most urgent/simple on top

* WN: 
* WN: review Model_Def.is_list_descr, replace by Term.is_list. Exception: make_values
    (values determine handling_lists by [[..], [..], ..])
* WN: intro-fn into M_Match
* WN: after--^^^ replace I_Model.descriptor_TEST with Model_Def.get_descr, ELIMI_Model.descriptor
* WN: thy --> ctxt in by_Add_, ? I_Model.T_TEST ?
      try to do the same in as many functions as possible
* WN: rename type Rule.rule -> Rule.T
* WN: use fn in add_single and further funs in i-model.sml
* WN: reconsider design max_variants/_TEST               
* WN: simplify "" in O_Model.to_string "(3, [\"1\", \"2\", \"3\"], #Find, AdditionalValues, [\"[u]\", \"[v]\"])"
* WN: review PblObj {meth, ...}
  * fill early (Model_Problem?) with Inc []  presents input-templates
  * try to minimise user's contact with Method: 
  * M_Model.by_i_models can probably be replaced by i_Model.s_make_complete and Pre_Conds.check(?_*)
* WN: undetected ERROR in autoCalculate --- due to Post_Conds.check? (_OLD .. dispels ?)
* WN: DEL get_simplifier: is only used in test/*
* WN: replace take in LibraryC with take from Library
* WN: Syntax.read_term @{context} --> Syntax.read_term\<^context> , see I_Model "UnIqE_tErM"
* WN: renaming in References
* WN: shift code from libraryC.sml to designated destination (ThyC, etc)
* WN: review ?code ERROR? in Rewrite.eval_true, see WN230329

* WN: unify get_ctxt in Solve_Step, Ctree (*DEPRECATED*)
* WN: Step_Specify.initialise: remove hdl in return-value, replace Step_Specify.initialise' xxx'
      ? which uses initialise !?
* WN: ? unify "no_met" with "empty_meth_id" from References.empty ?

* WN: proper ML antiquotations for "Tactical.Try" etc. --- be careful about unclear situations,
  e.g. "Tactical.Try" vs. "Lucas_Interpreter.Try";

* WN: ? Rational.Cancel_p; extend use of \<^theory> to \<^theory_context>

* WN: Check/clarify Context.theory_name vs. Context.theory_long_name.
    Context.theory_name seems to suffice after elimination of sessions.

* WN: more direct logical foundations wrt. Isabelle/HOL, eliminate many axiomatizations
    - quite often "axiomatization ..." can be turned into "lemma ... by auto"
      without further ado;
    - sometimes this requires to use more specific types / type classes;
    - sometimes this requires to use proper definitional mechanisms (e.g. 'primrec', 'fun');
    - a few "hard" cases will remain, to be reconsidered eventually (e.g. differentiation);

* WN: rename Pos.* -- Pos.ints, Pos.spec, Pos.empty, Pos.ints_empty

* WN: redesign transition from Specification to Solution: how relate 
    - Formalise.model with variants (e.g. VSCode_Example)
      reconsider separation of variants F_I, F_II, see MAWEN paper
    - !?! I_Model of MethodC          (fairly free sequence, dependent on Formalise.model)
    - !?! formal arguments of program (fixed sequence)

* WN: avoid too many uses of "structure Data = Theory_Data", instead use approx. 1 data slot
  per ML module, with type T = ... record or tuple (e.g. see @{apply} ML antiquotation)

* WN: rename *.sml to *.ML, potentially with tool support by MW;
* WN: rename src/Tools/isac/ to main/ (or something else);
        rename  src/Tools/isac/BridgeJEdit and test/Tools/isac/BridgeJEdit to */Tools/isac/BridgePIDE
