(* Algebra Einf"uhrung, Unterrichtsversuch IMST-Projekt
   author: Walther Neuper 2007
   (c) due to copyright terms
*)

theory AlgEin imports Rational begin
(*Poly + ..shouldbe sufficient, but norm_Poly required*)

consts

  (*new Descriptions in the related problems*)
  KantenUnten     :: "bool list => una"
  KantenSenkrecht :: "bool list => una"
  KantenOben      :: "bool list => una"
  KantenLaenge    :: "bool => una"
  Querschnitt     :: "bool => una"
  GesamtLaenge    :: "real => una"
  oben            :: real
  senkrecht       :: real
  unten           :: real

(** problems **)

problem pbl_algein : "Berechnung" = \<open>Rule_Set.empty\<close>

problem pbl_algein_numsym : "numerischSymbolische/Berechnung" = \<open>Rule_Set.empty\<close>
  Method_Ref: "Berechnung/erstNumerisch" "Berechnung/erstSymbolisch"
  Given: "KantenLaenge k_k" "Querschnitt q__q" (*q_ in Biegelinie.thy*) "KantenUnten u_u"
    "KantenSenkrecht s_s" "KantenOben o_o"
  Find: "GesamtLaenge l_l"

method met_algein : "Berechnung" =
  \<open>{rew_ord="tless_true", rls'= Rule_Set.Empty, calc = [], prog_rls = Rule_Set.Empty, where_rls = Rule_Set.Empty,
    errpats = [], rew_rls = Rule_Set.Empty}\<close>

method met_algein_numsym : "Berechnung/erstNumerisch" =
  \<open>{rew_ord="tless_true", rls'= Rule_Set.Empty, calc = [], prog_rls = Rule_Set.Empty, where_rls = Rule_Set.Empty,
    errpats = [], rew_rls = Rule_Set.Empty}\<close>

partial_function (tailrec) symbolisch_rechnen :: "bool \<Rightarrow> bool \<Rightarrow> bool list \<Rightarrow> bool list \<Rightarrow> bool list \<Rightarrow> real \<Rightarrow> bool"
  where
"symbolisch_rechnen k_k  q__q  u_u  s_s  o_o  l_l = (
  let
    t_t = Take (l_l = oben + senkrecht + unten);
    su_m = boollist2sum o_o;
    t_t = Substitute [oben = su_m] t_t;
    t_t = Substitute o_o t_t;
    t_t = Substitute [k_k, q__q] t_t;
    t_t = Repeat (Try (Rewrite_Set ''norm_Poly'')) t_t;
    su_m = boollist2sum s_s;
    t_t = Substitute [senkrecht = su_m] t_t;
    t_t = Substitute s_s t_t;
    t_t = Substitute [k_k, q__q] t_t;
    t_t = Repeat (Try (Rewrite_Set ''norm_Poly'')) t_t;
    su_m = boollist2sum u_u;
    t_t = Substitute [unten = su_m] t_t;
    t_t = Substitute u_u t_t;
    t_t = Substitute [k_k, q__q] t_t;
    t_t = Repeat (Try (Rewrite_Set ''norm_Poly'')) t_t
  in
    Try (Rewrite_Set ''norm_Poly'') t_t)"

method met_algein_numsym_1num : "Berechnung/erstNumerisch" =
  \<open>{rew_ord="tless_true", rls'= Rule_Set.empty, calc = [],
    prog_rls =
      Rule_Set.append_rules "srls_..Berechnung-erstSymbolisch" Rule_Set.empty 
        [\<^rule_eval>\<open>Prog_Expr.boollist2sum\<close> (Prog_Expr.eval_boollist2sum "")],
    where_rls = Rule_Set.empty, errpats = [], rew_rls = norm_Rational}\<close>
  Program: symbolisch_rechnen.simps
  Given: "KantenLaenge k_k" "Querschnitt q__q" "KantenUnten u_u" "KantenSenkrecht s_s" "KantenOben o_o"
  Find: "GesamtLaenge l_l"

partial_function (tailrec) symbolisch_rechnen_2 :: "bool \<Rightarrow> bool \<Rightarrow> bool list \<Rightarrow> bool list \<Rightarrow> bool list \<Rightarrow> real \<Rightarrow> bool"
  where 
"symbolisch_rechnen k_k q__q u_u s_s o_o l_l = (
  let
    t_t = Take (l_l = oben + senkrecht + unten);
    su_m = boollist2sum o_o;
    t_t = Substitute [oben = su_m] t_t;
    t_t = Substitute o_o t_t;
    t_t = Repeat (Try (Rewrite_Set ''norm_Poly'')) t_t;
    su_m = boollist2sum s_s;
    t_t = Substitute [senkrecht = su_m] t_t;
    t_t = Substitute s_s t_t;
    t_t = Repeat (Try (Rewrite_Set ''norm_Poly'')) t_t;
    su_m = boollist2sum u_u;
    t_t = Substitute [unten = su_m] t_t;
    t_t = Substitute u_u t_t;
    t_t = Repeat (Try (Rewrite_Set ''norm_Poly'')) t_t;
    t_t = Substitute [k_k, q__q] t_t
 in
   (Try (Rewrite_Set ''norm_Poly'')) t_t)"

method met_algein_symnum : "Berechnung/erstSymbolisch" =
  \<open>{rew_ord="tless_true", rls'= Rule_Set.empty, calc = [], 
    prog_rls =
      Rule_Set.append_rules "srls_..Berechnung-erstSymbolisch" Rule_Set.empty 
        [\<^rule_eval>\<open>Prog_Expr.boollist2sum\<close> (Prog_Expr.eval_boollist2sum "")],
    where_rls = Rule_Set.empty, errpats = [], rew_rls = norm_Rational}\<close>
  Program: symbolisch_rechnen.simps
  Given: "KantenLaenge k_k" "Querschnitt q__q" "KantenUnten u_u" "KantenSenkrecht s_s" "KantenOben o_o"
  Find: "GesamtLaenge l_l"

ML \<open>
\<close> ML \<open>
\<close>
end
